// BSSDemoAppDoc.cpp : implementation of the CBSSDemoAppDoc class
//

#include "stdafx.h"
#include "BSSDemoApp.h"

#include "BSSDemoAppDoc.h"



#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CBSSDemoAppDoc

IMPLEMENT_DYNCREATE(CBSSDemoAppDoc, CDocument)

BEGIN_MESSAGE_MAP(CBSSDemoAppDoc, CDocument)
    ON_COMMAND(ID_READ_BARCODES, &CBSSDemoAppDoc::OnReadBarcodes)
    ON_COMMAND(ID_FILE_OPEN, &CBSSDemoAppDoc::OnFileOpen)
END_MESSAGE_MAP()


// CBSSDemoAppDoc construction/destruction

CBSSDemoAppDoc::CBSSDemoAppDoc()
{
}

CBSSDemoAppDoc::~CBSSDemoAppDoc()
{
}


// CBSSDemoAppDoc diagnostics

#ifdef _DEBUG
void CBSSDemoAppDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CBSSDemoAppDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG


// Convert Unicode string to ANSI string
std::string UnicodeToStr( const TCHAR* pchStr )
{
    CArray<char> CharData;

    int iBuffSize = WideCharToMultiByte( CP_ACP, 0, pchStr, lstrlen( pchStr ) + 1, NULL, 0, NULL, NULL );

    CharData.SetSize( iBuffSize );

    WideCharToMultiByte( CP_ACP, 0, pchStr, lstrlen( pchStr ) + 1, &CharData[ 0 ], iBuffSize, NULL, NULL );

    return std::string( &CharData[ 0 ] );
}

// CBSSDemoAppDoc commands


void CBSSDemoAppDoc::OnFileOpen()
{
    CFileDialog FileDlg(
                         TRUE,
                         _T("bmp"),
                         NULL, 
                         OFN_HIDEREADONLY | OFN_FILEMUSTEXIST | OFN_PATHMUSTEXIST | OFN_EXPLORER | OFN_ENABLESIZING,
                         _T("BMP Files 8bpp-only (*.bmp)|*.bmp|") \
                         _T("All Files (*.*)|*.*||"),
                          NULL
                        );

	if( FileDlg.DoModal() == IDOK )
    {
        CString FileName = FileDlg.GetPathName();

        if( m_BitmapImg.Load8bppBitmap( UnicodeToStr( FileName.GetBuffer() ) ) != 0 )
        {
            AfxMessageBox( _T("Unable to load the image. Probably it is an unsupported file format.\nThis version supports only 8bpp grayscale images!") );
            return;
        }
        else
        {
            SetTitle( FileName );
        }
    }

    m_BarcodeData.RemoveAll();
    UpdateAllViews( NULL );
}

void CBSSDemoAppDoc::OnReadBarcodes()
{
    if( m_BitmapImg.GetDataPtr() == NULL )
        return;


    BSS_QRCodeInfo_Struct* pSymbolInfo = NULL;
    int nSymbolsRead = 0;
    
    int nRes = BSS_ReadQRCode( m_BitmapImg.GetDataPtr(),
                               m_BitmapImg.GetWidth(),
                               m_BitmapImg.GetHeight(),
                               m_BitmapImg.GetRowByteDist(),
                               TRUE,
                               &pSymbolInfo,
                               &nSymbolsRead );


    m_BarcodeData.RemoveAll();

    for( int n = 0; n < nSymbolsRead; n++ )
    {
        BarcodeInfoType Info;
        Info.pntCenter.x = pSymbolInfo[ n ].nCenterPosX;
        Info.pntCenter.y = pSymbolInfo[ n ].nCenterPosY;
        Info.strContent  = pSymbolInfo[ n ].pchData;

        m_BarcodeData.Add( Info );
    }
    
    BSS_ReleaseQRCodeResults( pSymbolInfo, nSymbolsRead );

    UpdateAllViews( NULL );
}
